<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 22/04/2015
 * Time: 17:12
 */

namespace Service\Calendar\Restriction\Strategy;


use Service\Calendar\TaskCalendar;

class ShouldEnd extends  RestrictionStrategyAbstract{


    public function getDatesBeginAndEnd($setAllocation = true)
    {
        $dateRestriction  = $this->task->getDateException();
        if(!empty($dateRestriction)){
            $dateEnd = $dateRestriction;
            $dateBegin = $this->taskCalendar->getDateBegin($this->task,$dateEnd,$setAllocation);
        }else{
            throw new \Exception('Null restriction date');
        }
        return array($dateBegin,$dateEnd);
    }

    public function getDatesByPrecursor($beginTask,$endTask)
    {
        //do not need treatment
    }


    public function getDatesMinAndMax($dateBeginMax,$dateEndMin)
    {
        if (!$this->task->isContainer()) {
            if ($this->task->usesDataControl()) {
                $dateException = $this->task->getDateException();
                if ($dateException) {
                    $dateEnd = clone $this->task->getDateException();
                } else {
                    $dateEnd = clone $this->task->getEstimatedEndDate();
                }
                $dateBegin = $this->taskCalendar->getDateBegin($this->task, $dateEnd, false);
                if ($dateEndMin < $dateEnd) {
                    $dateEndMin = $dateEnd;
                }
                if ($dateBeginMax > $dateBegin || is_null($dateBeginMax)) {
                    $dateBeginMax = $dateBegin;
                }
            }
        }
        return array($dateBeginMax,$dateEndMin);
    }
}